(*
 * Test question 3
 *)

open Question3

(* Partie test: ne pas modifier *)
let _ =
  let rec list_of_int accu = function
      0 -> 0::accu
    | n -> list_of_int (n::accu) (n-1)
  in
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (function (x,y) -> Printf.printf "(%d,%d); " x y) l;
    Printf.printf "]\n"
  in
  let rec gen_list accu = function
      0 -> accu
    | n when n>0 -> gen_list (((Random.int 10),(Random.int 10))::accu) (n-1)
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let usage = "Prog TP: question 3\nquestion3 graine taille" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size::_ ->
	    Random.init seed;
	    let l1 = gen_list [] size in
	    let l2 = gen_list [] size in
	      Printf.printf "l1 = " ;
	      print_int_list l1;
	      Printf.printf "l2 = " ;
	      print_int_list l2;
	      Printf.printf "join l1 l2 = \n" ;
	      print_int_list (join l1 l2);
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
