(*
 * Partiel 2008 01
 * Question 4
 *)

type ('a,'b) biList_a =
    Nil_a
  | B_a of 'a * ('a,'b) biList_b

and ('a,'b) biList_b =
    Nil_b
  | B_b of 'b * ('a,'b) biList_a

type ('a,'b) biList =
  | A of ('a,'b) biList_a
  | B of ('a,'b) biList_b

let rec deinterlace_a = function
    Nil_a -> ([],[])
  | B_a (a,t) ->
      let (l1,l2) = deinterlace_b t in
	(a::l1,l2)
and deinterlace_b = function
    Nil_b -> ([],[])
  | B_b (a,t) ->
      let (l1,l2) = deinterlace_a t in
	(l1,a::l2)

let deinterlace = function
  | A a -> deinterlace_a a
  | B b -> deinterlace_b b

let l1 = A(B_a(1, B_b("1", B_a(2, Nil_b))))
let l2 = B(B_b(1, B_a("1", B_b(2, Nil_a))));;

deinterlace l1;;
deinterlace l2;;
