type asm =
    Nop
  | PUSH of int
  | POPA
  | POPB
  | PUSHA
  | PUSHB
  | ADD
  | SUB
  | MUL
  | JMP of string
  | BEQ of int * string
  | BNZ of string
  | LAB of string
  | OUT
  | STOP
type register = { mutable a : int; mutable b : int; }
val prg : asm array
val eval : asm array -> unit
